Subject: Re: bug#41821: 28.0.50; read-directory-name in vc commands should provide defaults from projects

From: Eli Zaretskii <[email-masked]>
Date: Fri, 03 Jul 2020 14:48:07 +0300

> Cc: [email-masked], [email-masked]
> From: Dmitry Gutov <[email-masked]>
> Date: Fri, 3 Jul 2020 13:23:05 +0300
> 
> > You assume that most users don't know about or use M-n?  I do it all
> > the time, and would like to think others do as well.
> 
> I assume, yes.
> 
> But even if they do, I'm not sure how this extra capability could harm them.

??? Offering incorrect default doesn't cause harm?

> >> If an xref backend doesn't define the xref-backend-references method,
> >> the alternative is no references at all.
> > 
> > The alternative could be to start with the current directory, or ask
> > the user.
> 
> Using the current directory will result in worse results almost always, 

Worse than searching unrelated directories?  Perhaps you are thinking
about the use case where the project-related directories are indeed
relevant to the search.  I was thinking about the opposite use case.

> IME. Prompting the user every time is not a great experience either.

Not every time, only the first time.  Afterwards, the user has the
history.

> > But do we have xref backends that don't define the
> > xref-backend-references method?  If so, which ones don't?
> 
> Neither of the built-in ones does. :-)

But currently, they don't offer project-related defaults, do they?  At
least not in released versions of Emacs.

> >> Whether the current implementation will give wrong results, and how
> >> often, is difficult for me to predict. It also depends on what we
> >> consider a "wrong reference". etags and elisp backends don't always give
> >> perfect results for "find definition" either.
> > 
> > "Imperfect" and "completely wrong" is not the same at all.  Searching
> > the wrong directory hierarchy will get you the latter.
> 
> Perhaps. To get better results, the user will have to set up the project 
> configuration better.

Like what?  I don't think I understand how project configuration could
help in non project-related searches.